// Display a matrice di led PIC16F877

#include <16F877a.h>
#fuses HS,NOWDT,PUT,NOLVP,NOBROWNOUT,NOPROTECT
#use delay(clock=16000000)
#define INSTR_RATE 4000200
#define clock_pin PIN_A0
#define data_pin PIN_A2
#define clear_pin PIN_A1
#define DISPLAY_INHIBIT PIN_E0
#define BATT_PWR PIN_C5
#define SW1  PIN_A3
#define SW2  PIN_A4
//#bit RX_ENABLE = 0x18.4      //abilita ricezione RS232
//#byte RX_BUFFER = 0x1A       //registro FIFO RS232 hw
#include <1wire.c>

int32 Ticker;
int8 drift=100;                // parametro registrazione quarzo
int16 colonna;
int8 i;
int8 Seconds=0;
int8 Disptype = 0; 
int8 Year=14,Month=1,Days=1,Hours=0,Minutes=1; 
int16 offset=0;
int8 countmax = 4;  //Velocita' scorrimento
int8 count = 0;
int1 flag_rotaz=0;
int16 val1=0,val2=0;
int8 stringa[96];
int16 puntatore;
int8 finestringa;


//--------------------------Generatore caratteri----------------------------------
const int8 col_value[255]=
// 0 1   /-------------- 0 ---------------\  /--------------- 1 --------------\
        {0x3e, 0x51, 0x49, 0x45, 0x3e, 0x00, 0x00, 0x42, 0x7f, 0x40, 0x00, 0x00,
// 2 3   /-------------- 2 ---------------\  /--------------- 3 --------------\
         0x42, 0x61, 0x51, 0x49, 0x46, 0x00, 0x22, 0x41, 0x49, 0x49, 0x36, 0x00,
// 4 5   /-------------- 4 ---------------\  /--------------- 5 --------------\
         0x18, 0x14, 0x12, 0x7f, 0x10, 0x00, 0x27, 0x45, 0x45, 0x45, 0x39, 0x00,
// 6 7   /-------------- 6 ---------------\  /--------------- 7 --------------\
         0x3c, 0x4a, 0x49, 0x49, 0x30, 0x00, 0x01, 0x71, 0x09, 0x05, 0x03, 0x00,
// 8 9   /-------------- 8 ---------------\  /--------------- 9 --------------\
         0x36, 0x49, 0x49, 0x49, 0x36, 0x00, 0x06, 0x49, 0x49, 0x29, 0x1e, 0x00,
// 10 11 /-------------- A ---------------\  /--------------- B --------------\
         0x7e, 0x09, 0x09, 0x09, 0x7e, 0x00, 0x7f, 0x49, 0x49, 0x49, 0x36, 0x00,
// 12 13 /-------------- C ---------------\  /--------------- D --------------\
         0x3e, 0x41, 0x41, 0x41, 0x22, 0x00, 0x7f, 0x41, 0x41, 0x22, 0x1c, 0x00,
// 14 15 /-------------- E ---------------\  /--------------- F --------------\
         0x7f, 0x49, 0x49, 0x49, 0x41, 0x00, 0x7f, 0x09, 0x09, 0x09, 0x01, 0x00,
// 16 17 /-------------- G ---------------\  /--------------- H --------------\
         0x3e, 0x41, 0x49, 0x49, 0x7a, 0x00, 0x7f, 0x08, 0x08, 0x08, 0x7f, 0x00,
// 18 19 /-------------- I ---------------\  /--------------- J --------------\
         0x00, 0x41, 0x7f, 0x41, 0x00, 0x00, 0x20, 0x40, 0x41, 0x3f, 0x01, 0x00,
// 20 21 /-------------- K ---------------\  /--------------- L --------------\
         0x7f, 0x08, 0x14, 0x22, 0x41, 0x00, 0x7f, 0x40, 0x40, 0x40, 0x40, 0x00,
// 22 23 /-------------- M ---------------\  /--------------- N --------------\
         0x7f, 0x02, 0x0c, 0x02, 0x7f, 0x00, 0x7f, 0x04, 0x08, 0x10, 0x7f, 0x00,
// 24 25 /-------------- O ---------------\  /--------------- P --------------\
         0x3e, 0x41, 0x41, 0x41, 0x3e, 0x00, 0x7f, 0x09, 0x09, 0x09, 0x06, 0x00,
// 26 27 /-------------- Q ---------------\  /--------------- R --------------\
         0x3e, 0x41, 0x51, 0x21, 0x5e, 0x00, 0x7f, 0x09, 0x19, 0x29, 0x46, 0x00,
// 28 29 /-------------- S ---------------\  /--------------- T --------------\
         0x46, 0x49, 0x49, 0x49, 0x31, 0x00, 0x01, 0x01, 0x7f, 0x01, 0x01, 0x00,
// 30 31 /-------------- U ---------------\  /--------------- V --------------\
         0x3f, 0x40, 0x40, 0x40, 0x3f, 0x00, 0x1f, 0x20, 0x40, 0x20, 0x1f, 0x00,
// 32 33 /-------------- W ---------------\  /--------------- X --------------\
         0x3f, 0x40, 0x30, 0x40, 0x3f, 0x00, 0x63, 0x14, 0x08, 0x14, 0x63, 0x00,
// 34 35 /-------------- Y ---------------\  /--------------- Z --------------\
         0x07, 0x08, 0x70, 0x08, 0x07, 0x00, 0x61, 0x51, 0x49, 0x45, 0x43, 0x00,
// 36 37 /-------------- : ---------------\  /--------------- / --------------\
         0x00, 0x00, 0x22, 0x00, 0x00, 0x00, 0x20, 0x10, 0x08, 0x04, 0x02, 0x00,
// 38 39 /-------------- . ---------------\  /---------------'c --------------\
         0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x03, 0x03, 0x38, 0x44, 0x44, 0x28,
// 40 41 /--------------   ---------------\  /-------------- - ---------------\  
         0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x08, 0x08, 0x00, 0x00,
// 42    / break
         0xff, 0xff, 0xff};


// Test di verifica se l'anno e' bisestile.
// Versione ottimizzata per il periodo 2001 - 2099 

#define IS_LEAP(year) (year%4 == 0) 

void tasti();
void setup_clock();
int tasti_setup();
void set_anno();
void set_mese();
void set_giorno();
void set_ore();
void set_min();
void set_sec();
void set_drift();
void ck();
void clear();
void aggiorna();
void readtemp();
void avviso(int cicli, int s1, int s2, int s3, int s4, int s5);
void impostastringa();

//    Inizializza RTC 
 
void Initialize_RTC(void) 
{ 
  Ticker = INSTR_RATE + (drift<<2);             // inizializza il contatore al numero di cicli per secondo 
  setup_timer_1( T1_INTERNAL | T1_DIV_BY_1 );   // inizializza il Timer1 a 16 bit per l' interrupt 
                                                // esattamente ogni 65536 cicli di clock  
                                                // (circa 15 volte al secondo con quarzo a 4 MHz) 
  enable_interrupts( INT_TIMER1 );              // Avvia l'RTC 
} 


#int_TIMER1
void TIMER1_isr()                          
{ 
  Ticker -= 0xffff;                     // Decrementa ticker del numero di cicli per interrupt
  if ( Ticker < 0xffff )                // Se e' trascorso un secondo
  { 
    Ticker += INSTR_RATE;               // Incrementa ticker del numero di cicli per secondo
    Ticker +=drift<<2;                  
    Seconds++;                          // Incrementa il numero dei secondi
  } 

  if(Seconds == 60) {Minutes++; Seconds=0;
    if(Minutes == 60) {Hours++; Minutes=0; 
      if(Hours == 24) {Days++; Hours=0; 
        if (  (Days == 29 && Month == 2 && !IS_LEAP(Year)) 
           || (Days == 30 && Month == 2) 
           || (Days == 31 && (Month == 4 || Month == 6 || Month == 9 || Month == 11 )) 
           || (Days == 32) 
           ) {Month++;Days=1;} 
        if(Month == 13) {Year++; Month=1;} 
      }
    }
  }
} 


void tasti()
{
      if (!input(SW1)){
      avviso(30, 40,25,10,16,14);      // PAGE
      Disptype++;
      }
      if (Disptype > 6) Disptype = 0; // >5???
      if (!input(SW2))
      {
        avviso(30, 17,24,21,13,40);    // HOLD
        clear();
        aggiorna();
        Disptype =0;
        if (!input(SW2)) 
        {avviso(60, 28,14,29,30,25);   // SETUP
        if (!input(SW2)) setup_clock();
        }
      }      
}      

int tasti_setup()
{
      if (!input(SW1)){
       avviso(30, 40,18,23,12,40);   // INC
       return 1;
      }
      if (!input(SW2)){
       avviso(30, 28,14,29,40,40);   // SET
       if (!input(SW2))
       {avviso(60, 28,14,29,30,25);  // SETUP
        return 3;
       }
       else return 2;
      }
      return 0;
}

//messaggio visualizzato durante la pressione dei tasti
void avviso(int cicli, int s1, int s2, int s3, int s4, int s5) 
{int1 m_flag_rotaz;
 int8 p, m_count;
 int16 m_offset;
 // salva parametri
 m_flag_rotaz = flag_rotaz;
 m_offset = offset;
 m_count = count;
 //----carica i valori-------
 count = 0;
 offset = 186;
 stringa[31] = s1;
 stringa[32] = s2;
 stringa[33] = s3;
 stringa[34] = s4;
 stringa[35] = s5;
 // visualizza messaggio
 for(p = 0; p < cicli; p++)
  {
   for(i=0; i < 15; i++)
   ck();
  }
 // ripristina parametri
 flag_rotaz = m_flag_rotaz;
 offset = m_offset;
 count = m_count;
}

void setup_clock()   //imposta parametri
{ avviso(100, 12,21,24,12,20);  // CLOCK
  set_anno();
  set_mese();
  set_giorno();
  set_ore();
  set_min();
  set_sec();
  set_drift();
  clear();
  aggiorna();
}
         
void set_anno()      //imposta anno
{
   int tasto = 0;
   int1 fine = FALSE;
   flag_rotaz = 0;
   offset = 0;
   stringa[0] = 10;                  // A
   stringa[1] = 10;                  // A
   stringa[2] = 36;                  // :
   while(fine == FALSE)
     {ck();
     stringa[3] = Year/10;
     stringa[4] = Year%10;
     tasto = tasti_setup();
     if (tasto == 1)
      { Year++;
      if (Year == 100) Year = 0;
      }
     if (tasto == 2) fine = TRUE;
     }
}

void set_mese()      //imposta mese
{
   int tasto = 0;
   int1 fine = FALSE;
   flag_rotaz = 0;
   offset=0;
   stringa[0] = 22;                  // M
   stringa[1] = 22;                  // M
   stringa[2] = 36;                  // :
   while(fine == FALSE)
    {ck();
     stringa[3] = Month/10;
     stringa[4] = Month%10;
     tasto = tasti_setup();
     if (tasto == 1)
      { Month++;
      if (Month == 13) Month = 1;
      }
     if (tasto == 2) fine = TRUE;
    }
}

void set_giorno()   //imposta giorno
{
   int tasto = 0;
   int1 fine = FALSE;
   flag_rotaz = 0;
   offset=0;
   stringa[0] = 13;                  // D
   stringa[1] = 13;                  // D
   stringa[2] = 36;                  // :
   while(fine == FALSE)
    {ck();
     stringa[3] = Days/10;
     stringa[4] = Days%10;
     tasto = tasti_setup();
     if (tasto == 1)
      { Days++;
        if (  (Days == 29 && Month == 2 && !IS_LEAP(Year)) 
           || (Days == 30 && Month == 2) 
           || (Days == 31 && (Month == 4 || Month == 6 || Month == 9 || Month == 11 )) 
           || (Days == 32) 
           ) Days=1; 
      }
     if (tasto == 2) fine = TRUE;
    }
}

void set_ore()   //imposta ore
{
   int tasto = 0;
   int1 fine = FALSE;
   flag_rotaz = 0;
   offset=0;
   stringa[0] = 17;                  // H
   stringa[1] = 27;                  // R
   stringa[2] = 36;                  // :
   while(fine == FALSE)
    {ck();
     stringa[3] = Hours/10;
     stringa[4] = Hours%10;
     tasto = tasti_setup();
     if(tasto == 1)
      { Hours++;
      if (Hours >= 24) Hours = 0;
      }
     if(tasto == 2) fine = TRUE;
    }
}

void set_min()      //imposta minuti
{
   int tasto = 0;
   int1 fine = FALSE;
   flag_rotaz = 0;
   offset=0;
   stringa[0] = 22;                  // M
   stringa[1] = 23;                  // N
   stringa[2] = 36;                  // :
   while(fine == FALSE)
    {ck();
     if(offset == 30) offset=0;
     stringa[3] = Minutes/10;
     stringa[4] = Minutes%10;
     tasto = tasti_setup();
     if (tasto == 1)
      { Minutes++;
      if (Minutes >= 60) Minutes = 0;
      }
     if (tasto == 2) fine = TRUE;
    }
}

void set_sec()      //azzera secondi per sincronizzazione orario 
{
   int tasto = 0;
   int1 fine = FALSE;
   flag_rotaz = 0;
   offset=0;
   stringa[0] = 28;                  // S
   stringa[1] = 14;                  // E
   stringa[2] = 36;                  // :
   while(fine == FALSE)
    {ck();
     stringa[3] = Seconds/10;
     stringa[4] = Seconds%10;
     tasto = tasti_setup();
     if (tasto == 1)
      { if (Seconds >= 30) Minutes++;
      Seconds = 0;
      }
     if (tasto == 2) fine = TRUE;
    }
}
         
void set_drift()      //imposta parametro aggiustamento freq. quarzo
{
 int dr,tasto = 0;
 int1 fine = FALSE;
 flag_rotaz = 0;
 offset=0;
 drift = read_eeprom(1);
 dr = drift;
 stringa[0] = 13;                  // D
 stringa[1] = 27;                  // R
 while(fine == FALSE)
  {ck();
   stringa[2] = drift/100;           
   stringa[3] = (drift/10)%10;
   stringa[4] = drift%10;
   tasto = tasti_setup();
   if (tasto == 1) drift++;
   if (tasto == 2) fine = TRUE;
  }
   if(dr != drift) write_eeprom(1,drift);
}

void readtemp()      //legge temperatura da DS18B20 (12bit)
{
       int8 busy=0, temp1, temp2;
       int8 Cnt;
       int16 temperatura = 0;
       output_b(0x00);
       output_d(0x00);
       while (busy == 0) busy = onewire_read();         
       onewire_reset();
       onewire_write(0xCC);         // Comando Skip ROM
       onewire_write(0xBE);         // Comando Leggi ScratchPad
       temp1 = onewire_read();
       temp2 = onewire_read();
       Cnt=onewire_read();
       Cnt=onewire_read();
       Cnt=onewire_read();
       Cnt=onewire_read();
       Cnt=onewire_read();
       Cnt=onewire_read();
       Cnt=onewire_read();
       temperatura = make16(temp2,temp1); 
       if (bit_test(temperatura, 15)) 
       { 
        stringa[17] = 41;         //segno meno
        temperatura = ~temperatura + 1;                
       } else 
         stringa[17] = 40;        //spazio
       Cnt = temperatura&0xF;             // estrae ultimi 4 bit
       temperatura = temperatura >> 4 ;   // estrae parte intera 
       Cnt = Cnt*10;
       Cnt = Cnt/16;                      //risoluzione 12 bit = 1/16C
       onewire_reset();                      
       onewire_write(0xCC);                        // Comando Skip ROM
       onewire_write(0x44);                        // Comando conversione temp,
       if(temperatura > 9) stringa[17] = temperatura/10;       // decine/centinaia gradi
       stringa[18] = temperatura%10;               // unit gradi
       stringa[19] = 38;                           // punto decimale
       stringa[20] = Cnt;                          // decimi grado
       stringa[21]= 39;                            // c
}

void clear()    //cancella variabili stringa
{
 for(i=0;i<96;i++) stringa[i]=40;
}

void ck()      //Avanzamento visualizzazione
{
 if(colonna == 15) 
 {output_low(data_pin);
  if(flag_rotaz) count++;
  colonna = 0;
 }
 puntatore = colonna + offset;
 val1 = 6 * stringa[puntatore/6] + puntatore%6;
 val2 = 6 * stringa[(puntatore+15)/6] + (puntatore+15)%6;
 output_b(0x00);
 output_d(0x00);
 output_high(clock_pin);
 output_b(col_value[val2]);
 output_d(col_value[val1]);
 output_low(clock_pin);
 output_high(data_pin);
 delay_us(500);
 colonna++;
}

void impostastringa(){             // Imposta scritta scorrevole
      int m,n, carattere, tasto = 0;
      int1 fine = FALSE;     
      avviso(60, 28,14,29,30,25);   // SETUP
      flag_rotaz = 0;
      offset=0;
      clear();
      for(n=2;n<88;n++)
      {
       fine = FALSE;
       carattere = read_eeprom(n);
       if(carattere > 41) carattere = 41;
       stringa[4] = carattere;
       while(fine == FALSE)
        {ck();
         tasto = tasti_setup();
         if (tasto ==1)
          {
         carattere++;
         if(carattere > 41) carattere = 0;
         stringa[4] = carattere;
          }
         if(tasto == 2) 
          {
           fine = TRUE;
           write_eeprom((n),carattere);
          }
        }
        if(carattere == 39)
        {
         avviso(50,40,14,33,18,29);          //EXIT
         Disptype = 0;
         clear();
         aggiorna();
         break;
        }
        for (m=0; m<4; m++) stringa[m] = stringa[(m+1)];
      }
    }
    
void aggiorna()      //Aggiorna dati stringa per scorrimento
     {  
     //stringa[0..4] vuote per intro
//   -----------------------------30...65
     stringa[5] = Hours/10;
     if(stringa[5] == 0) stringa[5] = 40; //soppressione zero
     stringa[6] = Hours%10;
     stringa[7] = 36;
     stringa[8] = Minutes/10;
     stringa[9] = Minutes%10;
//   -----------------------------66...101
     stringa[11] = Days/10;
     if(stringa[11] == 0) stringa[11] = 40; //soppressione zero
     stringa[12] = Days%10;
     stringa[13] = 37;
     stringa[14] = Month/10;
     if(stringa[14] == 0) stringa[14] = 40; //soppressione zero
     stringa[15] = Month%10;    // 
//   -----------------------------102..125
     readtemp();                    //temperatura
//   -----------------------------126..155
//     stringa[21..25] vuote per outro
//   -----------------------------156..179
//     stringa[26] = Minutes/10;
//     stringa[27] = Minutes%10;
//     stringa[28] = 36;
//     stringa[29] = Seconds/10;
//     stringa[30] = Seconds%10;

     }
     
void main(void)
{  drift = read_eeprom(1);
   setup_adc_ports(NO_ANALOGS);
   Initialize_RTC();
   enable_interrupts(GLOBAL);
   //RX_ENABLE = 0;
   SET_TRIS_B(0x00);
   SET_TRIS_D(0x00);
   #use FAST_IO(B)
   #use FAST_IO(D)
   output_low(clear_pin);
   delay_ms(100);
   output_high(clear_pin);
   colonna = 0;
   offset = 0;
   clear();
   aggiorna();

   while(TRUE)
   {
   if(!input(BATT_PWR))              //se alimentazione ok
    {
    output_low(DISPLAY_INHIBIT);     //abilita display
    output_high(clear_pin);
    tasti();
    ck();
     if(Disptype == 0){
       flag_rotaz = 1;               // Rotazione 
       if(count>countmax)
         {
          offset++;
          count = 0;
          if(offset > 132)
          {
           aggiorna();
           offset=0;
          }//
         }
       if(offset == 30)       //Pausa su visualizzazione ore-min
        {
         avviso(200, stringa[5],stringa[6],36,stringa[8],stringa[9]);
         offset++;
        }
       }
     if(Disptype == 1){
       flag_rotaz = 1;               // Rotazione 
       if(count>countmax)
         {
          offset++;
          count = 0;
         }
       if(offset > 132)
         {
          clear();
          count = 0;
          offset =0;
          for(i=90;i>4;i--)
           {
            stringa[i]= read_eeprom(i-3);
            if(stringa[i] == 39)
             {
              finestringa = (int16)i*6;
              stringa[i] = 40;
              stringa[i+1] = 40;
              stringa[i+2] = 40;
              stringa[i+3] = 40;
              stringa[i+4] = 40;
             }
           }
          while(offset <= finestringa)
           {
            ck();
            tasti();
            if(count>countmax)          // Rotazione 
            {                           //
             offset++;
             count = 0;
            }
           }
           clear();
           aggiorna();
           offset = 0;
         }
       }

     if(Disptype == 2){             // Ore - Minuti
       flag_rotaz = 0;
       offset=30;
       if(Seconds%5)
        {
         stringa[5] = Hours/10;
         if(stringa[5] == 0) stringa[5] = 40; //soppressione zero
         stringa[6] = Hours%10;
         stringa[8] = Minutes/10;
         stringa[9] = Minutes%10;
        }
       }
     if(Disptype == 3){             // Minuti - Secondi
       flag_rotaz = 0;
       offset=156;
       stringa[26] = Minutes/10;
       stringa[27] = Minutes%10;
       stringa[28] = 36;
       stringa[29] = Seconds/10;
       stringa[30] = Seconds%10;
       }
     if(Disptype == 4){             // Data
       flag_rotaz = 0;
       offset=66;
       stringa[11] = Days/10;
       if(stringa[11] == 0) stringa[11] = 40; //soppressione zero
       stringa[12] = Days%10;
       stringa[13] = 37;
       stringa[14] = Month/10;
       if(stringa[14] == 0) stringa[14] = 40; //soppressione zero
       stringa[15] = Month%10;
       }
     if(Disptype == 5){             // Temperatura
       avviso(200, stringa[17],stringa[18],stringa[19],stringa[20],stringa[21]);
       readtemp();
       }
     if(Disptype == 6){             //visualizza scritta scorrevole
     int tasto = 0;
     int1 fine = FALSE;
     clear();
     flag_rotaz = 1;
     count = 0;
     offset =0;
     for(i=90;i>4;i--)
     {
      stringa[i]= read_eeprom(i-3);
      if(stringa[i] == 39)
      {
       finestringa = (int16)i*6;
       stringa[i] = 40;
       stringa[i+1] = 40;
       stringa[i+2] = 40;
       stringa[i+3] = 40;
       stringa[i+4] = 40;
      }
     }
     while(fine == FALSE)
      {
       ck();
       tasto = tasti_setup();
       if(count>countmax)          // Rotazione 
       {                           //
        offset++;
        count = 0;
        if(offset > (finestringa)) offset=0;
       }
       if(tasto == 1)
       {
        Disptype = 0;
        clear();
        aggiorna();
        fine = TRUE;
       }
       if(tasto == 3)
       {
        avviso(50, 40,22,14,28,16); // MESG
        impostastringa();
        fine = TRUE;
       }
      }
     }
   }
   else                            //se alimentazione a batteria 
   {
   output_high(DISPLAY_INHIBIT);   //spegne display
   output_low(clear_pin);          //reset shift register
   output_d(0);                    //spegne righe bus d
   output_b(0);                    //spegne righe bus b
   }
   }
}
